"""person_list = []

for line in file:
    find person name
    append person to person_list

sort person_list

go through the person list
and count number of times a person appears

Complexity:

Appending to a list is O(1), a constant operation
This is repeated n times where n is the number of lines, O(n)

Then, a list of length n is sorted. The complexity of this O(nlog n)
as we will see. So, the most costly step is O(n log n). This is a
better solution that "hanks_process2.py", but not as good as the
dictionary solution in "hanks_dictionary.py".

"""

if __name__ == '__main__':
    person_list = []
    for line in open('hanks.txt'):
        m = line.strip().split("|")
        person = m[0].strip()
        person_list.append(person)
        
    person_list.sort()
    movies = []
    cur_person = person_list[0]
    cur_count = 1
    for i in range(1,len(person_list)):
        person = person_list[i]
        if person == cur_person:
            cur_count += 1
        else:
            movies.append( [cur_person, cur_count] )
            cur_person = person
            cur_count = 1
    movies.append( [cur_person, cur_count] )
    for item in movies:
        print item
